routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
  if (Auth::guest())
    return view('auth/login');
  else
    return view('home');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home.index');

Route::get('usuario/permisos', 'BomberoController@permisos')->name('bombero.permisos');
Route::put('usuario/modificar', 'BomberoController@permisosupdate')->name('bombero.permisosupdate');
Route::resource('bombero','BomberoController',['except' => ['show']]);

Route::get('asistencia/rango', 'AsistenciaController@rango')->name('AsistenciaController.rango');
Route::resource('asistencia','AsistenciaController');

Route::get('puntuacion/variables', 'PuntuacionController@variables')->name('puntuacion.variables');
Route::get('puntuacion/anual', 'PuntuacionController@anual')->name('puntuacion.anual');
Route::get('puntuacion/anual/{bombero}/{inicio}/{fin}', 'PuntuacionController@tabla_anual')->name('puntuacion.tabla_anual');
Route::get('puntuacion/bomberos/{mes}/{anio}', 'PuntuacionController@bomberos')->name('puntuacion.bomberos');
Route::get('puntuacion/listar/{mes}/{anio}', 'PuntuacionController@listar')->name('puntuacion.listar');
Route::get('puntuacion/{mes}/{anio}/{bombero}/puntuacionmes', 'PuntuacionController@puntuacionmes')->name('puntuacion.puntuacionmes');
Route::post('puntuacion/variables', 'PuntuacionController@modificaar_variables')->name('puntuacion.modificar');
Route::resource('puntuacion','PuntuacionController');

Route::resource('vehiculo','VehiculoController');

Route::resource('material','MaterialController');

Route::get('servicio/llamada', 'ServicioController@llamada')->name('servicio.llamada');
Route::get('servicio/ultimos', 'ServicioController@ultimos')->name('servicio.ultimos');
Route::get('servicio/activo/{id}', 'ServicioController@finalizarActivo')->name('servicio.finalizarActivo');
route::get('servicio/finalizado', 'ServicioController@finalizado')->name('servicio.finalizado');
Route::get('servicio/estadistica', 'ServicioController@estadistica')->name('servicio.estadistica');
Route::get('servicio/{mes}/{anio}/tabla', 'ServicioController@tabla')->name('servicio.tabla');
Route::post('servicio/guardarPresentes', 'ServicioController@guardar_presentes')->name('servicio.guardar_presentes');
Route::post('servicio/iniciado', 'ServicioController@iniciado')->name('servicio.iniciado');
Route::put('servicio/editarPresentes', 'ServicioController@editar_presentes')->name('servicio.editar_presentes');
Route::put('servicio/activo/{id}/finalizar', 'ServicioController@guardarActivo')->name('servicio.guardarActivo');
Route::put('servicio/activo/{id}/salida', 'ServicioController@salida')->name('servicio.salida');
Route::resource('servicio','ServicioController');

Route::get('ingreso/{id}', 'IngresoController@show')->name('ingreso.show');
Route::get('ingreso/presentes/edit/{servicio}', 'IngresoController@editPresentes')->name('ingreso.editPresentes');
Route::get('ingreso/presentes/{servicio}/{acargo}', 'IngresoController@indexPresentes')->name('ingreso.indexPresentes');
Route::post('ingreso', 'IngresoController@guardarIngreso')->name('ingreso.guardarIngreso');
Route::delete('ingreso/{id}', 'IngresoController@borrarIngreso')->name('ingreso.borrarIngreso');

app/asistencia.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Asistencia extends Model
{
  protected $table = 'asistencia';
  protected $fillable = [
    'id', 'id_bombero','fecha_reunion'
  ];

  public function bombero(){
    return $this->hasOne(Bombero::class,"id","id_bombero");
  }

}

app/Http/Controllers/AsistenciaController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests;
use App\Http\Requests\AsistenciaRequest;
use App\asistencia;
use App\Bombero;
use App\Servicio;
use App\BomberoServicio;
use Illuminate\Support\Facades\Auth;

class AsistenciaController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth');
    }

    public function index()
    {
      $reuniones=asistencia::select('fecha_reunion')->orderBy('fecha_reunion', 'asc')->groupBy('fecha_reunion')->limit(10)->get();
      return view('asistencia/listar',compact('reuniones'));
    }

    public function rango(AsistenciaRequest $request)
    {
      if(Auth::user()->admin){
        list($dia, $mes, $año) = explode('/', $request['inicio']);
        $request['inicio']=$año.'-'.$mes.'-'.$dia;
        list($dia, $mes, $año) = explode('/', $request['fin']);
        $request['fin']=$año.'-'.$mes.'-'.$dia;
        $reuniones=asistencia::select('fecha_reunion')->orderBy('fecha_reunion', 'asc')->groupBy('fecha_reunion')->having('fecha_reunion','>=', $request['inicio'])->having('fecha_reunion','<=', $request['fin'])->limit(10)->get();
         return view('asistencia/listar',compact('reuniones'));
      }
      return view('auth/alerta');
    }

    public function create()
    {
      if(Auth::user()->admin){
        $bomberos=Bombero::where('activo', 1)->get();
        return view('asistencia/obligatoria',compact('bomberos'));
      }
      return view('auth/alerta');
    }

    public function store(AsistenciaRequest $request)
    {
      if(Auth::user()->admin){
        $data=$request->all();
        list($dia, $mes, $año) = explode('/', $data['fecha_reunion']);
        $data['fecha_reunion']=$año.'-'.$mes.'-'.$dia;
        foreach ($data as $key => $value) {
          if (strstr($key, '-', true)=="bombero") {
            $idbombero=substr($key, 8);
            asistencia::create(['id_bombero'=>$idbombero,'fecha_reunion'=>$data['fecha_reunion']]);
          }
        }
        return redirect()->route('asistencia.index');
      }
    }

    public function show($reunion)
    {
      $bomberos=Bombero::where('activo', 1)->get();
      return view('asistencia/info',compact('bomberos','reunion'));
    }

    public function edit($reunion)
    {
      if(Auth::user()->admin){
        $bomberos=Bombero::where('activo', 1)->get();
        return view('asistencia/editar',compact('bomberos','reunion'));
      }
      return view('auth/alerta');
    }


    public function update(Request $request, $id)
    {
      if(Auth::user()->admin){
        $data=$request->all();
        $reuniones=asistencia::where('fecha_reunion',$id)->get();
        $presentes=[];
        foreach ($data as $key => $value) {
          if (strstr($key, '-', true)=="bombero") {
            $idbombero=(integer)substr($key, 8);
            $presentes[]=$idbombero;
            if (!$reuniones->where('id_bombero',$idbombero)->first()) {
              asistencia::create(['id_bombero'=>$idbombero,'fecha_reunion'=>$id]);
            }
          }
        }
        foreach ($reuniones as $value) {
          if (!in_array($value->id_bombero,$presentes)) {
            $value->delete();
          }
        }
        return redirect()->route('asistencia.index');
      }
      return view('auth/alerta');
    }


    public function destroy($id)
    {
      if(Auth::user()->admin){
        $reuniones=asistencia::where('fecha_reunion',$id)->get();
        foreach ($reuniones as $value) {
          $value->delete();
        }
        return redirect()->route('asistencia.index');
      }
      return view('auth/alerta');
    }
}

resources/views/asistencia/asistencia.blade.php
<div class="col-lg-6 col-md-12 control-label" id="bombero-{{$bombero->id}}">
  {!! Form::label('bombero-'.$bombero->id, $bombero->nombre." ". $bombero->apellido,['class' => 'col-lg-7 col-md-5 control-label filtro']) !!}
  <div class="col-sm-4">
    {!! Form::checkbox('bombero-'.$bombero->id, 1,$vino, ['data-toggle' => "toggle", 'data-onstyle'=>"success", 'data-offstyle'=>"danger", 'data-on' => 'Presente', 'data-off' => 'Ausente']) !!}
  </div>
</div>

resources/views/asistencia/bombero.blade.php
@php
  $noacargo=!$ingresado->bombero->acargo($servicio)||!$ingresado->bombero->acargo($servicio)->a_cargo;
@endphp
@if ($asistselec<6 || !$noacargo)
  <div class="col-lg-6 col-sm-12 control-label" id="bombero-{{$ingresado->bombero->id}}">
    @php $presente='presentesOn' @endphp
@else
  <div class="col-lg-6 col-sm-12 control-label" id="bombero-{{$ingresado->bombero->id}}">
    @php $presente='presentesOff' @endphp
@endif
    {!! Form::label('bombero-'.$ingresado->bombero->id, $ingresado->bombero->nombre." ". $ingresado->bombero->apellido,['class' => 'col-lg-6 col-sm-5 control-label']) !!}
    <div class="col-sm-4">
      @if ($noacargo)
        {{Form::select('bombero-'.$ingresado->bombero->id,   config('selects.tipoAsistencia'), $asistselec,['class' => 'form-control'])}}
      @else
        {{Form::select('bombero-'.$ingresado->bombero->id,  [2 =>'a cargo'],2,['class' => 'form-control'])}}
      @endif
    </div>
    <i class="col-sm-1 glyphicon glyphicon-ok-circle {{$presente}}"></i>
  </div>

resources/views/asistencia/editar.blade.php
@extends('layouts.app')

@section('content')

<article class="col-md-12">
  <div class="panel panel-default">
    <div id="breadcrumb" class="panel-heading">
      <span class="fa fa-users" aria-hidden="true"></span>
      <h4>Editar Asistencia</h4>
    </div>
    <div class="panel-body">

      <div class="form-group col-sm-6">
        {{ Form::label('Buscar', 'Buscar: ',['class' => 'control-label col-sm-2 col-sm-offset-2']) }}
        <div class="col-sm-5">
          {{Form::text('busqueda', null, ['placeholder'=>"Buscar por nombre",'class' => 'form-control inputFilter'])}}
        </div>
      </div>
      {!! Form::open([ 'route' => ['asistencia.update',$reunion], 'class' => 'form-horizontal', 'method' => 'PUT']) !!}
        <div class="form-group {{ $errors->has('fecha_reunion') ? ' has-error' : '' }}">
          {!! Form::label('fecha_reunion', 'Fecha reunion',['class' => 'col-sm-2 control-label']) !!}
          <div class="col-sm-3">
            {!! Form::label('fecha_reunion', \Carbon\Carbon::parse($reunion)->format('d/m/Y') ,['class' => 'control-label']) !!}
            @if ($errors->has('fecha_reunion'))
                <span class="help-block">
                    <strong>{{ $errors->first('fecha_reunion') }}</strong>
                </span>
            @endif
          </div>
        </div>

        <div class="form-group bomberosparticipantes">
          @foreach($bomberos as $bombero)
            @php
              $vino=$bombero->presente($reunion);
            @endphp
            @include('asistencia.asistencia')
          @endforeach
        </div>


        <div class="form-group">
          <div class="col-md-3 col-md-offset-6">
            <button type="submit" class="btn btn-primary">
                <i class="glyphicon glyphicon-bell"></i> Finalizar
            </button>
          </div>
        </div>

      {!! Form::close() !!}

    </div>
  </div>
</article>
@endsection

@section('js')
  {!! Html::script('assets/js/ajaxpuntuacion.js') !!}
@endsection

resources/views/asistencia/info.blade.php
@extends('layouts.app')

@section('content')

<article class="col-md-12">
  <div class="panel panel-default">
    <div id="breadcrumb" class="panel-heading">
      <span class="fa fa-users" aria-hidden="true"></span>
      <h4>Asistencia del {{\Carbon\Carbon::parse($reunion)->format('d/m/Y')}}</h4>
    </div>
    <div class="panel-body">

      <div class="form-group">
        {{ Form::label('Buscar', 'Buscar: ',['class' => 'control-label col-sm-2 col-sm-offset-2']) }}
        <div class="col-sm-4">
          {{Form::text('busqueda', null, ['placeholder'=>"Apellido - Nombre",'class' => 'form-control inputFilter'])}}
        </div>
        <div class="col-sm-2">
          <a href="#" class="glyphicon glyphicon-ok-circle presentesOn" id="on"></a>
          <a href="#" class="glyphicon glyphicon-remove-circle presentesOff"id="off"></a>
          <a href="#" class="glyphicon glyphicon-ban-circle presentesall" id="all"></a>
        </div>
      </div>
      <br>
      <table  class="table table-bordered">
        <thead><!--Titulos de la tabla-->
          <tr>
            <th class="text-center">Nº legajo</th>
            <th class="text-center">Apellido Nombre</th>
            <th class="text-center">asistió</th>
          </tr>
        </thead>
        <tbody class="tableFilter">
          @foreach ($bomberos as $bombero)
            <tr id = "modal{{$bombero->id}}">
              <td class="text-center">{{$bombero->nro_legajo}}</td>
              <td class="text-center filtro">{{$bombero->apellido.' - '.$bombero->nombre}}</td>
              <td class="text-center">
                @if ($bombero->presente($reunion))
                  <a class="glyphicon glyphicon-ok-circle presentesOn" asistencia="onn"></a>
                @else
                  <a class="glyphicon glyphicon-remove-circle presentesOff" asistencia="off"></a>
                @endif
              </td>
            </tr>
          @endforeach
        </tbody>
        <tfoot>
          <tr>
            <td class="text-center" colspan="3"> lista de bomberos activos </td>
          </tr>
        </tfoot>
        <br>
      </table>

    </div>
  </div>
</article>
@endsection

@section('js')
  {!! Html::script('assets/js/ajaxpuntuacion.js') !!}
@endsection

resources/views/asistencia/ingresados.blade.php
<table  class="table table-striped">
  <thead><!--Titulos de la tabla-->
    <tr>
      <th class="text-center">Bombero</th>
      <th class="text-center">Presencia</th>
      <th class="text-center"></th>
    </tr>
  </thead>
  <tbody><!--Contenido de la tabla-->
    @foreach ($ingresados as $ingresado)
      <tr>
        <td class="text-center">{{ $ingresado->bombero->nombre." ". $ingresado->bombero->apellido}}</td>
        <td class="text-center"> En el Cuartel</td>
        <td>
          {{ Form::open(['route' => ['ingreso.borrarIngreso', $ingresado->bombero->id], 'method' => 'DELETE']) }}
              <button type="submit" title="Retirar bombero" class="glyphicon glyphicon-log-out"></button>
          {{ Form::close() }}
        </td>
      </tr>
    @endforeach
  </tbody>
  <tfoot>
    <tr>
      <td colspan="3" class="text-center">Bomberos ingresados</td>
    </tr>
  </tfoot>
</table>

resources/views/asistencia/listar.blade.php
@extends('layouts.app')

@section('content')
<article class="col-sm-12">
  <div class="panel panel-default">
    <div id="breadcrumb" class="panel-heading">
      <span class="fa fa-calendar" aria-hidden="true"></span>
      <h4>Reuniones realizadas</h4>
    </div>
    <div class="panel-body">
      {{Form::model(Request::all(),['route' => 'AsistenciaController.rango', 'class' => 'form-horizontal', 'method' => 'GET'])}}
      <div class="form-group">
        <div class="col-sm-6 col-md-4 {{ $errors->has('inicio') ? ' has-error' : '' }}">
          {!! Form::label('fecha_reunion', 'Buscar desde:',['class' => 'col-sm-6 control-label']) !!}
          <div class="col-sm-6">
            @if (count($reuniones)!=0)
            {!! Form::text('inicio',null,
            ['class' => 'form-control','placeholder'=>\Carbon\Carbon::parse($reuniones[0]->fecha_reunion )->format('d/m/Y')]) !!}
            @else
              {!! Form::text('inicio', null,['class' => 'form-control','placeholder'=>\Carbon\Carbon::now()->format('d/m/Y')]) !!}
            @endif

            @if ($errors->has('inicio'))
                <span class="help-block">
                    <strong>{{ $errors->first('inicio') }}</strong>
                </span>
            @endif
          </div>
        </div>
        <div class="col-sm-6 col-md-4 {{ $errors->has('fin') ? ' has-error' : '' }}">
          {!! Form::label('fecha_reunion', 'hasta:',['class' => 'col-sm-6 control-label']) !!}
          <div class="col-sm-6">
            {!! Form::text('fin',null,['class' => 'form-control','placeholder'=>\Carbon\Carbon::now()->format('d/m/Y')]) !!}

              @if ($errors->has('fin'))
                  <span class="help-block">
                      <strong>{{ $errors->first('fin') }}</strong>
                  </span>
              @endif
          </div>
        </div>
        <div class="col-sm-1">
          {{Form::submit('Buscar', ['class' => 'btn btn-primary']) }}
        </div>
      </div>
      {{Form::close()}}
      <div class="form-group form-horizontal">
        @foreach ($reuniones as $key => $asistencias)
          <div class="form-group col-sm-6">
            <div class="col-sm-8 text-center">
              <a href="{{ route('asistencia.show', $asistencias->fecha_reunion) }}">Reunión del {{\Carbon\Carbon::parse($asistencias->fecha_reunion)->format('d/m/Y')}}</a>
            </div>
            <div class="col-sm-4 text-center">
              @if (Auth::user()->admin)
                <div class="col-sm-3 col-sm-offset-2">
                  <a class="glyphicon glyphicon-edit" href="{{ route('asistencia.edit', $asistencias->fecha_reunion) }}"></a>
                </div>
                <div class="col-sm-3">
                  {{ Form::open(['route' => ['asistencia.destroy', $asistencias->fecha_reunion], 'method' => 'DELETE']) }}
                      <button type="submit" class="glyphicon glyphicon-trash"></button>
                  {{ Form::close() }}
                </div>
              @else
                <a class="glyphicon glyphicon-ban-circle" title="Sin permisos para eliminar/modificar"></a>
              @endif
            </div>
          </div>
        @endforeach
      </div>
    </div>
  </div>
</article>
@endsection

resources/views/asistencia/obligatoria.blade.php
@extends('layouts.app')

@section('content')

<article class="col-md-12">
  <div class="panel panel-default">
    <div id="breadcrumb" class="panel-heading">
      <span class="fa fa-users" aria-hidden="true"></span>
      <h4>Asistencia Obligatoria</h4>
    </div>
    <div class="panel-body">

      <div class="form-group col-sm-6">
        {{ Form::label('Buscar', 'Buscar: ',['class' => 'control-label col-sm-2 col-sm-offset-2']) }}
        <div class="col-sm-5">
          {{Form::text('busqueda', null, ['placeholder'=>"Buscar por nombre", 'class' => 'form-control inputFilter'])}}
        </div>
      </div>
      {!! Form::open([ 'route' => 'asistencia.store', 'class' => 'form-horizontal', 'method' => 'POST']) !!}

        <div class="form-group {{ $errors->has('fecha_reunion') ? ' has-error' : '' }}">
          {!! Form::label('fecha', 'Fecha reunion',['class' => 'col-sm-2 control-label']) !!}
          <div class="col-sm-3">
            {!! Form::text('fecha_reunion', \Carbon\Carbon::now(new DateTimeZone('America/Argentina/Buenos_Aires'))->format('d/m/Y') ,['class' => 'form-control']) !!}

            @if ($errors->has('fecha_reunion'))
                <span class="help-block">
                    <strong>{{ $errors->first('fecha_reunion') }}</strong>
                </span>
            @endif
          </div>
        </div>

        <div class="form-group tableFilter">
          @foreach($bomberos as $bombero)
            @php
              $vino=0;//como usasmos mismo tpl para editar en la alta asumismo que ninguno vino
            @endphp
            @include('asistencia.asistencia')
          @endforeach
        </div>


        <div class="form-group  col-lg-6">
            <button type="submit" class="btn btn-primary pull-right">
                <i class="glyphicon glyphicon-bell"></i> Finalizar
            </button>
        </div>

      {!! Form::close() !!}

    </div>
  </div>
</article>
@endsection

@section('js')
  {!! Html::script('assets/js/ajaxpuntuacion.js') !!}
@endsection

resources/views/asistencia/participantes.blade.php
@extends('layouts.app')

@section('content')

<article class="col-md-12">
  <div class="panel panel-default">
    <div id="breadcrumb" class="panel-heading">
      <span class="fa fa-users" aria-hidden="true"></span>
      <h4>Presentes al Servicio N° {{$servicio}}</h4>
    </div>
    <div class="panel-body">

      {!! Form::open([ 'route' => 'servicio.editar_presentes', 'class' => 'form-horizontal', 'method' => 'PUT']) !!}

        {!! Form::hidden('servicio', $servicio) !!}

        <div class="form-group bomberosparticipantes">
          @foreach($bomberos as $ingresado)
            @php
              $asistselec=$ingresado->tipo_id;
            @endphp
            @include('asistencia.bombero')
          @endforeach
        </div>


        <div class="form-group">
          <div class="col-md-3 col-md-offset-6">
            <button type="submit" class="btn btn-primary">
                <i class="glyphicon glyphicon-bell"></i> Finalizar
            </button>
          </div>
        </div>

      {!! Form::close() !!}
    </div>
  </div>
</article>
@endsection

@section('js')
  {!! Html::script('assets/js/ajaxbombero.js') !!}
@endsection

resources/views/asistencia/presentes.blade.php
@extends('layouts.app')

@section('content')

<article class="col-md-12">
  <div class="panel panel-default">
    <div id="breadcrumb" class="panel-heading">
      <span class="fa fa-users" aria-hidden="true"></span>
      <h4>Presentes al Servicio N° {{$servicio}}</h4>
    </div>
    <div class="panel-body">
      {!! Form::open([ 'route' => 'servicio.guardar_presentes', 'class' => 'form-horizontal', 'method' => 'POST']) !!}

        {!! Form::hidden('servicio', $servicio) !!}
        
        <div class="form-group bomberosparticipantes">
          {{--  esto tengo que acomodar: todos los bomberos--}}
          @foreach($bomberos as $bombero)
            @if ($bombero->ingresado)
              @php
                if ($acargo==$bombero->id) {
                  $asistselec=2;
                }else {
                  $asistselec=5;
                }
              @endphp
            @else
              @php
                $asistselec=10;
              @endphp
            @endif
            @php
              $ingresado = (object) array('bombero' => $bombero);
            @endphp
            @include('asistencia.bombero')
          @endforeach
        </div>

        <div class="form-group">
          <div class="col-md-3 col-md-offset-6">
            <button type="submit" class="btn btn-primary">
                <i class="glyphicon glyphicon-bell"></i> Finalizar
            </button>
          </div>
        </div>

      {!! Form::close() !!}
    </div>
  </div>
</article>
@endsection

@section('js')
  {!! Html::script('assets/js/ajaxbombero.js') !!}
@endsection

resources/views/asistencia/servicio.blade.php
@extends('layouts.app')

@section('content')

<article class="col-md-12">
  <div class="panel panel-default">
    <div id="breadcrumb" class="panel-heading">
      <span class="fa fa-users" aria-hidden="true"></span>
      <h4>Presentes al Servicio N° {{$servicio}}</h4>
    </div>
    <div class="panel-body form-horizontal">
      <div class="form-group bomberosparticipantes">
        @foreach($bomberos as $ingresado)
          @php
            $asistselec=$ingresado->tipo_id;
          @endphp
          @include('asistencia.bombero')
        @endforeach
      </div>
      <div class="col-sm-3 col-sm-offset-6">
        <a href="{{route('servicio.index')}}" class="">
          <button type="submit" class="btn btn-primary glyphicon glyphicon-ok">
          Volver</button></a>
      </div>
    </div>
  </div>
</article>
@endsection

@section('js')
  {!! Html::script('assets/js/ajaxbombero.js') !!}
@endsection